﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using MyEntLibCMS.Model;

namespace MyEntLibCMS.IDAL
{
   public interface ILoginRepository
    {
       /// <summary>
       /// 登录系统
       /// </summary>
       /// <param name="loginAccount">账号</param>
       /// <param name="password">密码</param>
       /// <returns>登录信息</returns>
       Login Login(string loginAccount, string password);

       /// <summary>
       /// 修改密码
       /// </summary>
       /// <param name="loginAccount">账号</param>
       /// <param name="newPassword">新密码</param>
       /// <returns></returns>
       bool UpdatePassword(string loginAccount, string newPassword);

       /// <summary>
       /// 修改登录IP,时间
       /// </summary>
       /// <param name="userID">用户ID</param>
       /// <param name="loginIP">IP</param>
       /// <param name="loginTime">登录时间</param>
       /// <returns></returns>
       bool UpdateLoginIP(string userID, string loginIP, DateTime loginTime);
    }
}
